﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

/// <summary>
/// Summary description for QuoteProcessor
/// </summary>
public class QuoteProcessor
{
    public double getBuildingsQuote(BuildingsDTO buildingsDetails)
    {
        double premium = 0.0;
        double basicQuote = buildingsDetails.MarketValue * 0.002;
        String propertyType = buildingsDetails.PropertyType;
        if (propertyType.Equals("apartment"))
        {
            premium = basicQuote * 0.95;
        }
        if (propertyType.Equals("semi"))
        {
            premium = basicQuote * 1.05;
        }
        if (propertyType.Equals("terraced"))
        {
            premium = basicQuote;
        }
        if (propertyType.Equals("detached"))
        {
            premium = basicQuote * 1.1;
        }
        premium = premium + (buildingsDetails.BedroomCount * (premium / 100));
        String yearString = buildingsDetails.ConstructionDate.Year.ToString().Substring(2, 2);
        int year = int.Parse(yearString);
        switch (year)
        {
            case 00:
                premium += premium * .04;
                break;
            case 01:
                premium += premium * .03;
                break;
            case 51:
                premium += premium * .02;
                break;
            case 71:
                premium += premium * .01;
                break;
        }
        if (buildingsDetails.ConstructionType.Equals("timber"))
        {
            premium += (premium * 0.1);
        }
        return premium;
    }

    public double getContentsQuote(ContentsDTO contentsDetails)
    {
        Boolean accidentalCover = contentsDetails.AccidentalCover;
        int cover = contentsDetails.CoverAmount;
        int deductible = contentsDetails.DeductibleAmount;
        double premium = cover * 0.004;
        if (accidentalCover)
        {
            premium *= 1.25;
        }
        if (deductible >= 1000)
        {
            premium -= (premium * 0.2);
        }
        else
        {
            if (deductible >= 500)
            {
                premium -= (premium * 0.1);
            }
        }
        return premium;
    }
}
